﻿--
-- Script was generated by Devart dbForge Studio for MySQL, Version 8.0.40.0
-- Product home page: http://www.devart.com/dbforge/mysql/studio
-- Script date 09/09/2019 13:06:41
-- Server version: 5.5.5-10.1.40-MariaDB
-- Client version: 4.1
--

-- 
-- Disable foreign keys
-- 
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;

-- 
-- Set SQL mode
-- 
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

-- 
-- Set character set the client will use to send SQL statements to the server
--
SET NAMES 'utf8';

DROP DATABASE IF EXISTS world;

CREATE DATABASE IF NOT EXISTS world
CHARACTER SET latin1
COLLATE latin1_swedish_ci;

--
-- Set default database
--
USE world;

--
-- Create view `vista5a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista5a
AS
SELECT
  `country`.`Continent` AS `Continent`,
  AVG(`country`.`LifeExpectancy`) AS `espvidaMedia`
FROM `country`
GROUP BY `country`.`Continent`;

--
-- Create view `vista5b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista5b
AS
SELECT
  MAX(`vista5a`.`espvidaMedia`) AS `espvidaMayor`
FROM `vista5a`;

--
-- Create view `vista5c`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista5c
AS
SELECT
  `vista5a`.`Continent` AS `Continent`
FROM (`vista5a`
  JOIN `vista5b`
    ON ((`vista5a`.`espvidaMedia` = `vista5b`.`espvidaMayor`)));

--
-- Create view `vista5d`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista5d
AS
SELECT DISTINCT
  `country`.`Code` AS `Code`
FROM (`vista5c`
  JOIN `country`
    ON ((`vista5c`.`Continent` = `country`.`Continent`)));

--
-- Create view `vista5`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista5
AS
SELECT
  AVG(`city`.`Population`) AS `poblacionMedia`
FROM (`vista5d`
  JOIN `city`
    ON ((`vista5d`.`Code` = `city`.`CountryCode`)));

--
-- Create view `vista4a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista4a
AS
SELECT
  `country`.`Continent` AS `Continent`,
  AVG(`country`.`Population`) AS `poblMedia`
FROM `country`
GROUP BY `country`.`Continent`;

--
-- Create view `vista4b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista4b
AS
SELECT
  MAX(`vista4a`.`poblMedia`) AS `poblMayor`
FROM `vista4a`;

--
-- Create view `vista4c`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista4c
AS
SELECT
  `vista4a`.`Continent` AS `Continent`
FROM (`vista4a`
  JOIN `vista4b`
    ON ((`vista4a`.`poblMedia` = `vista4b`.`poblMayor`)));

--
-- Create view `vista4`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista4
AS
SELECT
  `city`.`Name` AS `Name`
FROM ((`vista4c`
  JOIN `country`
    ON ((`vista4c`.`Continent` = `country`.`Continent`)))
  JOIN `city`
    ON ((`country`.`Code` = `city`.`CountryCode`)));

--
-- Create view `vista9a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista9a
AS
SELECT
  `c`.`CountryCode` AS `CountryCode`,
  COUNT(0) AS `numeroLenguas`
FROM `countrylanguage` `c`
GROUP BY `c`.`CountryCode`;

--
-- Create view `vista9b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista9b
AS
SELECT
  MIN(`v`.`numeroLenguas`) AS `minimo`
FROM `vista9a` `v`;

--
-- Create view `vista9`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista9
AS
SELECT
  `c`.`Name` AS `name`
FROM ((`vista9a`
  JOIN `vista9b`
    ON ((`vista9a`.`numeroLenguas` = `vista9b`.`minimo`)))
  JOIN `country` `c`
    ON ((`vista9a`.`CountryCode` = `c`.`Code`)));

--
-- Create view `vista8a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista8a
AS
SELECT
  `c`.`Continent` AS `Continent`,
  COUNT(0) AS `numeroLenguas`
FROM (`country` `c`
  JOIN `countrylanguage` `c1`
    ON ((`c`.`Code` = `c1`.`CountryCode`)))
GROUP BY `c`.`Continent`;

--
-- Create view `vista8b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista8b
AS
SELECT
  MAX(`v`.`numeroLenguas`) AS `maximo`
FROM `vista8a` `v`;

--
-- Create view `vista8`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista8
AS
SELECT
  `v`.`Continent` AS `Continent`
FROM (`vista8a` `v`
  JOIN `vista8b` `v1`
    ON ((`v`.`numeroLenguas` = `v1`.`maximo`)));

--
-- Create view `vista7a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista7a
AS
SELECT
  `c`.`CountryCode` AS `CountryCode`,
  MAX(`c`.`Percentage`) AS `maximo`
FROM `countrylanguage` `c`
GROUP BY `c`.`CountryCode`;

--
-- Create view `vista7b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista7b
AS
SELECT
  `c`.`CountryCode` AS `CountryCode`,
  `c`.`Language` AS `Language`
FROM (`countrylanguage` `c`
  JOIN `vista7a`
    ON (((`c`.`Percentage` = `vista7a`.`maximo`)
    AND (`c`.`CountryCode` = `vista7a`.`CountryCode`))));

--
-- Create view `vista7`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista7
AS
SELECT
  `c`.`Name` AS `Name`,
  `v`.`Language` AS `Language`
FROM (`vista7b` `v`
  JOIN `country` `c`
    ON ((`v`.`CountryCode` = `c`.`Code`)));

--
-- Create view `vista10a`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista10a
AS
SELECT
  COUNT(0) AS `COUNT(*)`
FROM (`countrylanguage`
  JOIN `country`
    ON (((`countrylanguage`.`CountryCode` = `country`.`Code`)
    AND (`country`.`Name` = 'Spain'))));

--
-- Create view `vista10b`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista10b
AS
SELECT
  `countrylanguage`.`CountryCode` AS `CountryCode`
FROM `countrylanguage`
GROUP BY `countrylanguage`.`CountryCode`
HAVING (COUNT(0) = (SELECT
    `vista10a`.`COUNT(*)`
  FROM `vista10a`));

--
-- Create view `vista10`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista10
AS
SELECT
  `country`.`Name` AS `Name`
FROM (`vista10b`
  JOIN `country`
    ON ((`vista10b`.`CountryCode` = `country`.`Code`)));

--
-- Create view `vista6`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista6
AS
SELECT
  `city`.`Population` AS `POBLACION`,
  `city`.`Name` AS `CIUDAD`,
  `country`.`Name` AS `PAIS`,
  `country`.`Continent` AS `CONTINENTE`
FROM (`country`
  JOIN `city`
    ON (((`country`.`Code` = `city`.`CountryCode`)
    AND (`country`.`Capital` = `city`.`ID`))));

--
-- Create view `vista3`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista3
AS
SELECT
  `c`.`Continent` AS `Continent`,
  `c`.`Region` AS `Region`,
  AVG(`c`.`Population`) AS `poblacionMedia`
FROM `country` `c`
GROUP BY `c`.`Continent`,
         `c`.`Region`;

--
-- Create view `vista2`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista2
AS
SELECT
  `c1`.`Language` AS `Language`
FROM (`country` `c`
  JOIN `countrylanguage` `c1`
    ON ((`c`.`Code` = `c1`.`CountryCode`)))
WHERE (`c`.`LocalName` = 'España');

--
-- Create view `vista1`
--
CREATE
DEFINER = 'root'@'localhost'
VIEW IF NOT EXISTS vista1
AS
SELECT
  `c1`.`Language` AS `Language`
FROM (`country` `c`
  JOIN `countrylanguage` `c1`
    ON ((`c`.`Code` = `c1`.`CountryCode`)))
WHERE ((`c`.`LocalName` = 'España')
AND (`c1`.`IsOfficial` = 'T'));

-- 
-- Restore previous SQL mode
-- 
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;

-- 
-- Enable foreign keys
-- 
/*!40014 SET FOREIGN_KEY_CHECKS = @OLD_FOREIGN_KEY_CHECKS */;